// Persistence of Vision Ray Tracer Scene Description File
// File: twovarturf.pov
// Vers: 3.5
// Desc: Basic Scene Example
// Date: 2001/11/01
// Auth: Ingo Janssen
//

#version 3.5;
#include "twovar.inc"

global_settings {assumed_gamma 1.0}
camera { location  <0, 4.5, -14.0> look_at <0,-1.5,0>}
light_source {<500,500,-500> rgb 1}

//#declare Fuv=function(u,v){(10*sin((u^2+v^2)^0.5))/(2+(u^2+y^2)^0.5)}
//#declare Fuv=function(u,v){sin(u)^3*cos(v)}

#declare Fp=function{pattern{wood sine_wave turbulence 0.1}}
#declare Fuv=function(u,v){Fp(u/3,v/3,0)}

object {
   TwoVarSurf(<-6,6>,<-6,6>,50,50,"")
   uv_mapping
   pigment{checker color rgb <0,0,0.2> color rgb <1,0.85,0.85> scale 0.5}
   finish{specular 0.4}
   rotate <-110,45,0>
}

